---
title: Create Credential Verification Session (NATIVE)
description: Use the POST {{apiPath}}/v1/environments/{{envID}}/presentationSessions to initiate verification of a user credential using the native protocol of the PingOne Credentials service. Each credential verification session silently times out after 5 minutes.
component: pingone-api
page_id: pingone-api:credentials:credential-verifications/create-credential-verification-presentation-session-native
canonical_url: https://developer.pingidentity.com/pingone-api/credentials/credential-verifications/create-credential-verification-presentation-session-native.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Credential Verification Session (NATIVE)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/presentationSessions
```

Use the `POST {{apiPath}}/v1/environments/{{envID}}/presentationSessions` to initiate verification of a user credential using the native protocol of the PingOne Credentials service. Each credential verification session silently times out after 5 minutes.

### Prerequisites

* Refer to [Credential Verifications](../credential-verifications.html) for important overview information.

> **Collapse: Request Model**
>
> Refer to [Credential Verifications session data model](../credential-verifications.html#credential-verifications-session-data-model) for full property descriptions.
>
> | Property                      | Type      | Required |
> | ----------------------------- | --------- | -------- |
> | `issuerFilter.dids`           | String\[] | Optional |
> | `issuerFilter.environmentIds` | String\[] | Optional |
> | `message`                     | String    | Optional |
> | `protocol`                    | String    | Optional |
> | `requestedCredentials`        | Object\[] | Required |
> | `requestedCredentials.keys`   | String\[] | Optional |
> | `requestedCredentials.type`   | String    | Required |
> | `timeoutSeconds`              | Integer   | Optional |

|   |                                                                                                                                                                                                                                            |
| - | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
|   | Content of `requestedCredentials` differs by `protocol`. The `protocol` of `NATIVE` permits multiple credential types per request and uses `requestedCredentials.keys` to return only those selected data fields for each credential type. |

|   |                                                                                                                                                                                                                                                                   |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | The service searches all environments listed in `issuerFilter.environmentIds` for the issuer of the presented credential. If the user presents a credential that is not from one of these issuers, the verification fails with `status` of `VERIFICATION_FAILED`. |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
        {
            "type": "Driver License",
            "keys": [
                "First Name",
                "Last Name"
            ]
        }
    ],
    "timeoutSeconds" : 30
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/presentationSessions' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
        {
            "type": "Driver License",
            "keys": [
                "First Name",
                "Last Name"
            ]
        }
    ],
    "timeoutSeconds" : 30
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/presentationSessions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""message"": ""Some custom message for the user.""," + "\n" +
@"    ""protocol"": ""NATIVE""," + "\n" +
@"    ""requestedCredentials"": [" + "\n" +
@"        {" + "\n" +
@"            ""type"": ""Driver License""," + "\n" +
@"            ""keys"": [" + "\n" +
@"                ""First Name""," + "\n" +
@"                ""Last Name""" + "\n" +
@"            ]" + "\n" +
@"        }" + "\n" +
@"    ]," + "\n" +
@"    ""timeoutSeconds"" : 30" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/presentationSessions"
  method := "POST"

  payload := strings.NewReader(`{
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
        {
            "type": "Driver License",
            "keys": [
                "First Name",
                "Last Name"
            ]
        }
    ],
    "timeoutSeconds" : 30
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/presentationSessions HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
        {
            "type": "Driver License",
            "keys": [
                "First Name",
                "Last Name"
            ]
        }
    ],
    "timeoutSeconds" : 30
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"message\": \"Some custom message for the user.\",\n    \"protocol\": \"NATIVE\",\n    \"requestedCredentials\": [\n        {\n            \"type\": \"Driver License\",\n            \"keys\": [\n                \"First Name\",\n                \"Last Name\"\n            ]\n        }\n    ],\n    \"timeoutSeconds\" : 30\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/presentationSessions")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/presentationSessions",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
      {
        "type": "Driver License",
        "keys": [
          "First Name",
          "Last Name"
        ]
      }
    ],
    "timeoutSeconds": 30
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/presentationSessions',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "message": "Some custom message for the user.",
    "protocol": "NATIVE",
    "requestedCredentials": [
      {
        "type": "Driver License",
        "keys": [
          "First Name",
          "Last Name"
        ]
      }
    ],
    "timeoutSeconds": 30
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/presentationSessions"

payload = json.dumps({
  "message": "Some custom message for the user.",
  "protocol": "NATIVE",
  "requestedCredentials": [
    {
      "type": "Driver License",
      "keys": [
        "First Name",
        "Last Name"
      ]
    }
  ],
  "timeoutSeconds": 30
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/presentationSessions');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "message": "Some custom message for the user.",\n    "protocol": "NATIVE",\n    "requestedCredentials": [\n        {\n            "type": "Driver License",\n            "keys": [\n                "First Name",\n                "Last Name"\n            ]\n        }\n    ],\n    "timeoutSeconds" : 30\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/presentationSessions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "message": "Some custom message for the user.",
  "protocol": "NATIVE",
  "requestedCredentials": [
    {
      "type": "Driver License",
      "keys": [
        "First Name",
        "Last Name"
      ]
    }
  ],
  "timeoutSeconds": 30
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"message\": \"Some custom message for the user.\",\n    \"protocol\": \"NATIVE\",\n    \"requestedCredentials\": [\n        {\n            \"type\": \"Driver License\",\n            \"keys\": [\n                \"First Name\",\n                \"Last Name\"\n            ]\n        }\n    ],\n    \"timeoutSeconds\" : 30\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/presentationSessions")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

202 Accepted

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/presentationSessions/16bab70c-32c1-41ca-9c84-d062aedd095f"
        },
        "qr": {
            "href": "https://api.pingone.com/v1/distributedid/requests/e4974bd1-0094-4586-8e43-28c4409d4bd7"
        },
        "appOpenUrl": {
            "href": "https://shocard.pingone.com/appopen?u=https%3A%2F%2Fapi.pingone.com%2Fv1%2Fdistributedid%2Frequests%2Fe4974bd1-0094-4586-8e43-28c4409d4bd7"
        }
    },
    "id": "16bab70c-32c1-41ca-9c84-d062aedd095f",
    "createdAt": "2024-10-24T16:39:52.991303314Z",
    "expiresAt": "2024-10-24T16:40:22.991301494Z",
    "status": "INITIAL"
}
```
